diff -Naur --exclude=autom4te.cache openssh-3.4p1/sshconnect1.c openssh-3.4p1-gsi/sshconnect1.c
--- openssh-3.4p1/sshconnect1.c	Thu Jun  6 14:57:34 2002
+++ openssh-3.4p1-gsi/sshconnect1.c	Mon Sep 30 12:13:26 2002
@@ -51,6 +51,17 @@
 #include "canohost.h"
 #include "auth.h"
 
+#ifdef GSSAPI
+#include "ssh-gss.h"
+#include "bufaux.h"
+
+/*
+ * MD5 hash of host and session keys for verification. This is filled
+ * in in ssh_login() and then checked in try_gssapi_authentication().
+ */
+unsigned char ssh_key_digest[16];
+#endif /* GSSAPI */
+
 /* Session id for the current session. */
 u_char session_id[16];
 u_int supported_authentications = 0;
@@ -947,6 +958,409 @@
 	return 0;
 }
 
+#ifdef GSSAPI
+#ifdef GSI
+char * get_gsi_name()
+{
+  OM_uint32 maj_stat;
+  OM_uint32 min_stat;
+  gss_name_t pname = GSS_C_NO_NAME;
+  gss_buffer_desc tmpname;
+  gss_buffer_t tmpnamed = &tmpname;
+  char *retname;
+  gss_OID_set oidset;
+  gss_cred_id_t gss_cred = GSS_C_NO_CREDENTIAL;
+
+  gss_create_empty_oid_set(&min_stat,&oidset);
+  gss_add_oid_set_member(&min_stat,&supported_mechs[GSS_GSI].oid,&oidset);
+  maj_stat = gss_acquire_cred(&min_stat,
+                              GSS_C_NO_NAME,
+                              GSS_C_INDEFINITE,
+                              oidset,
+                              GSS_C_INITIATE,
+                              &gss_cred,
+                              NULL,
+                              NULL);
+
+  if (maj_stat != GSS_S_COMPLETE) {
+      goto error;
+  }
+
+  debug("calling gss_inquire_cred");
+  maj_stat = gss_inquire_cred(&min_stat,
+                              gss_cred,
+                              &pname,
+                              NULL,
+                              NULL,
+                              NULL);
+  if (maj_stat != GSS_S_COMPLETE) {
+      goto error;
+  }
+
+  maj_stat = gss_display_name(&min_stat,
+	                      pname,
+			      tmpnamed,
+			      NULL);
+  if (maj_stat != GSS_S_COMPLETE) {
+      goto error;
+  }
+  debug("gss_display_name finsished");
+  retname = (char *)malloc(tmpname.length + 1);
+  if (!retname) {
+      goto error;
+  }
+  memcpy(retname, tmpname.value, tmpname.length);
+  retname[tmpname.length] = '\0';
+
+  gss_release_name(&min_stat, &pname);
+  gss_release_buffer(&min_stat, tmpnamed);
+
+  return retname;
+
+ error:
+  debug("Failed to set GSI username from credentials");
+  ssh_gssapi_error(&supported_mechs[GSS_GSI].oid, maj_stat, min_stat);
+  return NULL;
+}
+#endif /* GSI */
+
+int try_gssapi_authentication(char *host, Options *options)
+{
+  char *service_name = NULL;
+  gss_buffer_desc name_tok;
+  gss_buffer_desc send_tok;
+  gss_buffer_desc recv_tok;
+  gss_buffer_desc *token_ptr;
+  gss_name_t target_name = NULL;
+  gss_ctx_id_t gss_context;
+  gss_OID_desc mech_oid;
+  gss_OID name_type;
+  gss_OID_set gss_mechs, my_mechs;
+  int my_mech_num, i, present;
+  OM_uint32 maj_stat;
+  OM_uint32 min_stat;
+  int ret_stat = 0;                             /* 1 == success */
+  OM_uint32 req_flags = 0;
+  OM_uint32 ret_flags;
+  int type;
+  char *xhost;
+  unsigned int slen;
+  Gssctxt *ctx = NULL;
+
+  /* Make a copy of the host name, in case it was returned by a
+   * previous call to gethostbyname(). */	
+  xhost = xstrdup(host);
+
+  /* If xhost is the loopback interface, switch it to our
+     true local hostname. */
+  resolve_localhost(&xhost);
+
+  /* Make sure we have the FQHN. Some GSSAPI implementations don't do
+   * this for us themselves */
+  make_fqhn(&xhost);
+
+  /*
+   * Default flags
+   */
+  req_flags |= GSS_C_REPLAY_FLAG;
+
+  /* Do mutual authentication */
+  req_flags |= GSS_C_MUTUAL_FLAG;
+
+  service_name = (char *) xmalloc(strlen("host") +
+				  strlen(xhost) +
+				  2 /* 1 for '@', 1 for NUL */);
+
+  sprintf(service_name, "host@%s", xhost);
+
+  xfree(xhost);
+  xhost = NULL;
+
+  name_type = GSS_C_NT_HOSTBASED_SERVICE;
+
+  debug("Service name is %s", service_name);
+
+  /* Forward credentials? */
+
+#ifdef GSSAPI
+  if(options->gss_deleg_creds) {
+    debug("Delegating GSSAPI credentials");
+    req_flags |= GSS_C_DELEG_FLAG;
+  }
+#endif /* GSSAPI */
+
+  debug("req_flags = %u", (unsigned int)req_flags);
+
+  name_tok.value = service_name;
+  name_tok.length = strlen(service_name) + 1;
+  maj_stat = gss_import_name(&min_stat, &name_tok,
+                             name_type, &target_name);
+
+  free(service_name);
+  service_name = NULL;
+
+  if (maj_stat != GSS_S_COMPLETE) {
+    ssh_gssapi_error(GSS_C_NO_OID, maj_stat, min_stat);
+    goto cleanup;
+  }
+
+  maj_stat = gss_indicate_mechs(&min_stat, &gss_mechs);
+
+  if (maj_stat != GSS_S_COMPLETE) {
+    ssh_gssapi_error(GSS_C_NO_OID, maj_stat, min_stat);
+    goto cleanup;
+  }
+
+  /* The GSSAPI supports the mechs in gss_mechs, but which ones do
+     we have credentials for?  We only get one try, so we don't want
+     to propose a mechanism we know is going to fail. */
+  maj_stat = gss_create_empty_oid_set(&min_stat, &my_mechs);
+  for (i=0; supported_mechs[i].name != NULL; i++) {
+      maj_stat = gss_test_oid_set_member(&min_stat, &supported_mechs[i].oid,
+					 gss_mechs, &present);
+      if (present) {
+	  if (!GSS_ERROR(ssh_gssapi_client_ctx(&ctx, &supported_mechs[i].oid,
+					       host))) {
+	      maj_stat = gss_add_oid_set_member(&min_stat,
+						&supported_mechs[i].oid,
+						&my_mechs);
+	      debug("GSSAPI mechanism %s supported", supported_mechs[i].name);
+	  } else {
+	      debug("no credentials for GSSAPI mechanism %s",
+		    supported_mechs[i].name);
+	  }
+      } else {
+	  debug("GSSAPI mechanism %s not supported", supported_mechs[i].name);
+      }
+  }
+
+  /*
+   * Send over a packet to the daemon, letting it know we're doing
+   * GSSAPI and our mech_oid(s).
+   */
+  debug("Sending mech oid(s) to server");
+  packet_start(SSH_CMSG_AUTH_GSSAPI);
+  packet_put_int(my_mechs->count); /* Number of mechs we're sending */
+#ifdef GSI
+  /* Send GSI before Kerberos, because if GSI fails, we can always fall
+     back and try regular Kerberos authentication with our Kerberos cred. */
+  maj_stat = gss_test_oid_set_member(&min_stat, &supported_mechs[GSS_GSI].oid,
+				     my_mechs, &present);
+  if (present) {
+      packet_put_string(supported_mechs[GSS_GSI].oid.elements,
+                        supported_mechs[GSS_GSI].oid.length);
+  }
+#endif
+  for (my_mech_num = 0; my_mech_num < my_mechs->count; my_mech_num++) {
+#ifdef GSI
+      /* Skip GSI.  We already sent it above. */
+      if ((my_mechs->elements[my_mech_num].length ==
+	   supported_mechs[GSS_GSI].oid.length) &&
+	  memcmp(my_mechs->elements[my_mech_num].elements,
+		 supported_mechs[GSS_GSI].oid.elements,
+		 my_mechs->elements[my_mech_num].length) == 0) {
+	  continue;
+      }
+#endif
+      packet_put_string(my_mechs->elements[my_mech_num].elements,
+                        my_mechs->elements[my_mech_num].length);
+  }
+  packet_send();
+  packet_write_wait();
+
+  /*
+   * Get reply from the daemon to see if our mech was acceptable
+   */
+  type = packet_read();
+
+  switch (type) {
+  case SSH_SMSG_AUTH_GSSAPI_RESPONSE:
+      debug("Server accepted mechanism");
+      /* Successful negotiation */
+      break;
+
+  case SSH_MSG_AUTH_GSSAPI_ABORT:
+      debug("Unable to negotiate GSSAPI mechanism type with server");
+      packet_get_all();
+      goto cleanup;
+
+  default:
+      packet_disconnect("Protocol error during GSSAPI authentication:"
+                        " packet type %d received",
+                        type);
+      /* Does not return */
+  }
+
+  /* Read the mechanism the server returned */
+  mech_oid.elements = packet_get_string(&slen);
+  mech_oid.length = slen;	/* safe typecast */
+  packet_get_all();
+
+  /*
+   * Perform the context-establishement loop.
+   *
+   * On each pass through the loop, token_ptr points to the token
+   * to send to the server (or GSS_C_NO_BUFFER on the first pass).
+   * Every generated token is stored in send_tok which is then
+   * transmitted to the server; every received token is stored in
+   * recv_tok, which token_ptr is then set to, to be processed by
+   * the next call to gss_init_sec_context.
+   *
+   * GSS-API guarantees that send_tok's length will be non-zero
+   * if and only if the server is expecting another token from us,
+   * and that gss_init_sec_context returns GSS_S_CONTINUE_NEEDED if
+   * and only if the server has another token to send us.
+   */
+
+  token_ptr = GSS_C_NO_BUFFER;
+  gss_context = GSS_C_NO_CONTEXT;
+
+  do {
+    maj_stat =
+      gss_init_sec_context(&min_stat,
+                           GSS_C_NO_CREDENTIAL,
+                           &gss_context,
+                           target_name,
+                           &mech_oid,
+                           req_flags,
+                           0,
+                           NULL,        /* no channel bindings */
+                           token_ptr,
+                           NULL,        /* ignore mech type */
+                           &send_tok,
+                           &ret_flags,
+                           NULL);       /* ignore time_rec */
+
+    if (token_ptr != GSS_C_NO_BUFFER)
+      (void) gss_release_buffer(&min_stat, &recv_tok);
+
+    if (maj_stat != GSS_S_COMPLETE && maj_stat != GSS_S_CONTINUE_NEEDED) {
+      ssh_gssapi_error(&mech_oid, maj_stat, min_stat);
+
+      /* Send an abort message */
+      packet_start(SSH_MSG_AUTH_GSSAPI_ABORT);
+      packet_send();
+      packet_write_wait();
+
+      goto cleanup;
+    }
+
+    if (send_tok.length != 0) {
+      debug("Sending authenticaton token...");
+      packet_start(SSH_MSG_AUTH_GSSAPI_TOKEN);
+      packet_put_string((char *) send_tok.value, send_tok.length);
+      packet_send();
+      packet_write_wait();
+
+      (void) gss_release_buffer(&min_stat, &send_tok);
+    }
+
+    if (maj_stat == GSS_S_CONTINUE_NEEDED) {
+
+      debug("Continue needed. Reading response...");
+
+      type = packet_read();
+
+      switch(type) {
+
+      case SSH_MSG_AUTH_GSSAPI_TOKEN:
+        /* This is what we expected */
+        break;
+
+      case SSH_MSG_AUTH_GSSAPI_ABORT:
+        debug("Server aborted GSSAPI authentication.");
+        packet_get_all();
+        goto cleanup;
+
+      default:
+        packet_disconnect("Protocol error during GSSAPI authentication:"
+                          " packet type %d received",
+                          type);
+        /* Does not return */
+      }
+
+      recv_tok.value = packet_get_string(&slen);
+      recv_tok.length=slen;	/* safe typecast */
+      packet_get_all();
+      token_ptr = &recv_tok;
+    }
+  } while (maj_stat == GSS_S_CONTINUE_NEEDED);
+
+  /* Success */
+  ret_stat = 1;
+
+  debug("GSSAPI authentication successful");
+
+  /*
+   * Read hash of host and server keys and make sure it
+   * matches what we got earlier.
+   */
+  debug("Reading hash of server and host keys...");
+  type = packet_read();
+
+  if (type == SSH_MSG_AUTH_GSSAPI_ABORT) {
+    debug("Server aborted GSSAPI authentication.");
+    packet_get_all();
+    ret_stat = 0;
+    goto cleanup;
+
+  } else if (type == SSH_SMSG_AUTH_GSSAPI_HASH) {
+    gss_buffer_desc wrapped_buf;
+    gss_buffer_desc unwrapped_buf;
+    int conf_state;
+    gss_qop_t qop_state;
+
+
+    wrapped_buf.value = packet_get_string(&slen);
+    wrapped_buf.length=slen;	/* safe typecast */
+    packet_get_all();
+
+    maj_stat = gss_unwrap(&min_stat,
+                          gss_context,
+                          &wrapped_buf,
+                          &unwrapped_buf,
+                          &conf_state,
+                          &qop_state);
+
+    if (maj_stat != GSS_S_COMPLETE) {
+      ssh_gssapi_error(&mech_oid, maj_stat, min_stat);
+      packet_disconnect("Verification of SSHD keys through GSSAPI-secured channel failed: "
+                        "Unwrapping of hash failed.");
+    }
+
+    if (unwrapped_buf.length != sizeof(ssh_key_digest)) {
+      packet_disconnect("Verification of SSHD keys through GSSAPI-secured channel failed: "
+                        "Size of key hashes do not match (%d != %d)!",
+                        (int)unwrapped_buf.length,
+			(int)sizeof(ssh_key_digest));
+    }
+
+    if (memcmp(ssh_key_digest, unwrapped_buf.value, sizeof(ssh_key_digest)) != 0) {
+      packet_disconnect("Verification of SSHD keys through GSSAPI-secured channel failed: "
+                        "Hashes don't match!");
+    }
+
+    debug("Verified SSHD keys through GSSAPI-secured channel.");
+
+    gss_release_buffer(&min_stat, &unwrapped_buf);
+
+  } else {
+      packet_disconnect("Protocol error during GSSAPI authentication:"
+                        "packet type %d received", type);
+      /* Does not return */
+  }
+
+
+ cleanup:
+  if (target_name != NULL)
+      (void) gss_release_name(&min_stat, &target_name);
+
+  return ret_stat;
+}
+
+#endif /* GSSAPI */
+
+
 /*
  * SSH1 key exchange
  */
@@ -998,6 +1412,45 @@
 		log("Warning: This may be due to an old implementation of ssh.");
 	}
 
+#ifdef GSSAPI
+  {
+    MD5_CTX md5context;
+    Buffer buf;
+    unsigned char *data;
+    unsigned int data_len;
+
+    /*
+     * Hash the server and host keys. Later we will check them against
+     * a hash sent over a secure channel to make sure they are legit.
+     */
+    debug("Calculating MD5 hash of server and host keys...");
+
+    /* Write all the keys to a temporary buffer */
+    buffer_init(&buf);
+
+    /* Server key */
+    buffer_put_bignum(&buf, server_key->rsa->e);
+    buffer_put_bignum(&buf, server_key->rsa->n);
+
+    /* Host key */
+    buffer_put_bignum(&buf, host_key->rsa->e);
+    buffer_put_bignum(&buf, host_key->rsa->n);
+
+    /* Get the resulting data */
+    data = (unsigned char *) buffer_ptr(&buf);
+    data_len = buffer_len(&buf);
+
+    /* And hash it */
+    MD5_Init(&md5context);
+    MD5_Update(&md5context, data, data_len);
+    MD5_Final(ssh_key_digest, &md5context);
+
+    /* Clean up */
+    buffer_clear(&buf);
+    buffer_free(&buf);
+  }
+#endif /* GSSAPI */
+
 	/* Get protocol flags. */
 	server_flags = packet_get_int();
 	packet_set_protocol_flags(server_flags);
@@ -1140,6 +1593,12 @@
 ssh_userauth1(const char *local_user, const char *server_user, char *host,
     Sensitive *sensitive)
 {
+#ifdef GSSAPI
+#ifdef GSI
+  	const char *save_server_user = NULL;
+#endif /* GSI */
+#endif /* GSSAPI */
+
 #ifdef KRB5
 	krb5_context context = NULL;
 	krb5_auth_context auth_context = NULL;
@@ -1149,12 +1608,56 @@
 	if (supported_authentications == 0)
 		fatal("ssh_userauth1: server supports no auth methods");
 
+#ifdef GSSAPI
+#ifdef GSI
+  /* if no user given, tack on the subject name after the server_user.
+   * This will allow us to run gridmap early to get real user
+   * This name will start with /C=
+   */
+  if ((supported_authentications & (1 << SSH_AUTH_GSSAPI)) &&
+      options.gss_authentication) {
+      char * retname;
+      char * newname;
+
+
+      save_server_user = server_user;
+
+      retname = get_gsi_name();
+
+      if (retname) {
+        debug("passing gssapi name '%s'", retname);
+        if (server_user) {
+          newname = (char *) malloc(strlen(retname) + strlen(server_user) + 4);
+          if (newname) {
+            strcpy(newname, server_user);
+            if(options.implicit) {
+                strcat(newname,":i:");
+	    } else {
+                strcat(newname,":x:");
+	    }
+            strcat(newname, retname);
+            server_user = newname;
+            free(retname);
+          }
+        }
+      }
+      debug("server_user %s", server_user);
+  }
+#endif /* GSI */
+#endif /* GSSAPI */
+
 	/* Send the name of the user to log in as on the server. */
 	packet_start(SSH_CMSG_USER);
 	packet_put_cstring(server_user);
 	packet_send();
 	packet_write_wait();
 
+#if defined(GSI)
+  if(save_server_user)
+    {
+      server_user = save_server_user;
+    }
+#endif
 	/*
 	 * The server should respond with success if no authentication is
 	 * needed (the user has no password).  Otherwise the server responds
@@ -1168,6 +1671,31 @@
 	if (type != SSH_SMSG_FAILURE)
 		packet_disconnect("Protocol error: got %d in response to SSH_CMSG_USER", type);
 
+#ifdef GSSAPI
+  /* Try GSSAPI authentication */
+  if ((supported_authentications & (1 << SSH_AUTH_GSSAPI)) &&
+      options.gss_authentication)
+    {
+      debug("Trying GSSAPI authentication...");
+      try_gssapi_authentication(host, &options);
+
+      /*
+       * XXX Hmmm. Kerberos authentication only reads a packet if it thinks
+       * the authentication went OK, but the server seems to always send
+       * a packet back. So I'm not sure if I'm missing something or
+       * the Kerberos code is broken. - vwelch 1/27/99
+       */
+
+      type = packet_read();
+      if (type == SSH_SMSG_SUCCESS)
+        return; /* Successful connection. */
+      if (type != SSH_SMSG_FAILURE)
+        packet_disconnect("Protocol error: got %d in response to Kerberos auth", type);
+
+      debug("GSSAPI authentication failed");
+    }
+#endif /* GSSAPI */
+	
 #ifdef KRB5
 	if ((supported_authentications & (1 << SSH_AUTH_KERBEROS)) &&
 	    options.kerberos_authentication) {
diff -Naur --exclude=autom4te.cache openssh-3.4p1/sshconnect2.c openssh-3.4p1-gsi/sshconnect2.c
--- openssh-3.4p1/sshconnect2.c	Sun Jun 23 16:23:21 2002
+++ openssh-3.4p1-gsi/sshconnect2.c	Mon Sep 30 12:13:26 2002
@@ -48,6 +48,10 @@
 #include "msg.h"
 #include "pathnames.h"
 
+#ifdef GSSAPI
+#include "ssh-gss.h"
+#endif
+
 /* import */
 extern char *client_version_string;
 extern char *server_version_string;
@@ -77,10 +81,26 @@
 ssh_kex2(char *host, struct sockaddr *hostaddr)
 {
 	Kex *kex;
+#ifdef GSSAPI
+	char *orig, *gss;
+	int len;
+#endif
 
 	xxx_host = host;
 	xxx_hostaddr = hostaddr;
 
+#ifdef GSSAPI
+	/* Add the GSSAPI mechanisms currently supported on this client to
+	 * the key exchange algorithm proposal */
+	orig = myproposal[PROPOSAL_KEX_ALGS];
+	gss = ssh_gssapi_mechanisms(0,host);
+	if (gss) {
+	   len = strlen(orig)+strlen(gss)+2;
+	   myproposal[PROPOSAL_KEX_ALGS]=xmalloc(len);
+	   snprintf(myproposal[PROPOSAL_KEX_ALGS],len,"%s,%s",gss,orig);
+	}
+#endif
+
 	if (options.ciphers == (char *)-1) {
 		log("No valid ciphers for protocol version 2 given, using defaults.");
 		options.ciphers = NULL;
@@ -108,11 +128,27 @@
 		myproposal[PROPOSAL_SERVER_HOST_KEY_ALGS] =
 		    options.hostkeyalgorithms;
 
+#ifdef GSSAPI
+        /* If we've got GSSAPI algorithms, then we also support the
+         * 'null' hostkey, as a last resort */
+	if (gss) {
+		orig=myproposal[PROPOSAL_SERVER_HOST_KEY_ALGS];
+		len = strlen(orig)+sizeof(",null");
+		myproposal[PROPOSAL_SERVER_HOST_KEY_ALGS]=xmalloc(len);
+		snprintf(myproposal[PROPOSAL_SERVER_HOST_KEY_ALGS],len,"%s,null",orig);  
+	}
+#endif
+
 	/* start key exchange */
 	kex = kex_setup(myproposal);
 	kex->client_version_string=client_version_string;
 	kex->server_version_string=server_version_string;
 	kex->verify_host_key=&verify_host_key_callback;
+	kex->host=host;
+
+#ifdef GSSAPI
+	kex->options.gss_deleg_creds=options.gss_deleg_creds;
+#endif
 
 	xxx_kex = kex;
 
@@ -159,6 +195,8 @@
 	Sensitive *sensitive;
 	/* kbd-interactive */
 	int info_req_seen;
+	/* generic */
+	void *methoddata;
 };
 struct Authmethod {
 	char	*name;		/* string to compare against server's list */
@@ -181,6 +219,14 @@
 int	userauth_kbdint(Authctxt *);
 int	userauth_hostbased(Authctxt *);
 
+#ifdef GSSAPI
+int	userauth_external(Authctxt *authctxt);
+int	userauth_gssapi(Authctxt *authctxt);
+void	input_gssapi_response(int type, u_int32_t plen, void *ctxt);
+void	input_gssapi_token(int type, u_int32_t plen, void *ctxt);
+void	input_gssapi_hash(int type, u_int32_t plen, void *ctxt);
+#endif
+
 void	userauth(Authctxt *, char *);
 
 static int sign_and_send_pubkey(Authctxt *, Key *, sign_cb_fn *);
@@ -191,6 +237,16 @@
 static char *authmethods_get(void);
 
 Authmethod authmethods[] = {
+#ifdef GSSAPI
+	{"external-keyx",
+		userauth_external,
+		&options.gss_authentication,
+		NULL},
+	{"gssapi",
+		userauth_gssapi,
+		&options.gss_authentication,
+		NULL},
+#endif
 	{"hostbased",
 		userauth_hostbased,
 		&options.hostbased_authentication,
@@ -256,6 +312,7 @@
 	authctxt.success = 0;
 	authctxt.method = authmethod_lookup("none");
 	authctxt.authlist = NULL;
+	authctxt.methoddata = NULL;
 	authctxt.sensitive = sensitive;
 	authctxt.info_req_seen = 0;
 	if (authctxt.method == NULL)
@@ -278,6 +335,11 @@
 void
 userauth(Authctxt *authctxt, char *authlist)
 {
+	if (authctxt->methoddata!=NULL) {
+		xfree(authctxt->methoddata);
+		authctxt->methoddata=NULL;
+	}
+           
 	if (authlist == NULL) {
 		authlist = authctxt->authlist;
 	} else {
@@ -327,6 +389,8 @@
 		fatal("input_userauth_success: no authentication context");
 	if (authctxt->authlist)
 		xfree(authctxt->authlist);
+	if (authctxt->methoddata)
+		xfree(authctxt->methoddata);
 	clear_auth_state(authctxt);
 	authctxt->success = 1;			/* break out */
 }
@@ -428,6 +492,172 @@
 
 }
 
+#ifdef GSSAPI
+int 
+userauth_gssapi(Authctxt *authctxt)
+{
+	Gssctxt *gssctxt;
+	static int mech=0;
+
+	if (datafellows & SSH_OLD_GSSAPI) return 0;
+	
+	/* Try each mechanism in turn.  Give up if we've tried all
+	   supported mechanisms.
+	 */
+	if (mech==GSS_LAST_ENTRY) return 0;
+	
+	/* Initialise as much of our context as we can, so failures can be
+	 * trapped before sending any packets.
+	 */
+	ssh_gssapi_build_ctx(&gssctxt);
+
+	if (ssh_gssapi_import_name(gssctxt,authctxt->host)) {
+		return(0);
+	}
+	
+	authctxt->methoddata=(void *)gssctxt;
+		
+	packet_start(SSH2_MSG_USERAUTH_REQUEST);
+#ifdef GSI
+        if(options.implicit && !(datafellows & SSH_BUG_GSS_EMPTYUSER)) {
+	    packet_put_cstring("");
+	} else {
+#endif
+	    packet_put_cstring(authctxt->server_user);
+#ifdef GSI
+	}
+#endif
+	packet_put_cstring(authctxt->service);
+        packet_put_cstring(authctxt->method->name);
+
+	/* FIXME: This assumes that our current GSSAPI implementation
+	 * supports all of the mechanisms listed in supported_mechs.
+	 * This may not be the case - we should use something along
+	 * the lines of the code in gss_genr to remove the ones that
+	 * aren't supported */
+
+	/* Try one GSSAPI mechanism at a time. */
+	packet_put_int(1);
+	packet_put_string(supported_mechs[mech].oid.elements,
+			  supported_mechs[mech].oid.length);
+        packet_send();
+        packet_write_wait();
+
+        dispatch_set(SSH2_MSG_USERAUTH_GSSAPI_RESPONSE,&input_gssapi_response);
+        dispatch_set(SSH2_MSG_USERAUTH_GSSAPI_TOKEN,&input_gssapi_token);
+	
+	mech++;			/* Move to next mechanism for next time. */
+
+        return 1;
+}
+
+void
+input_gssapi_response(int type, u_int32_t plen, void *ctxt) 
+{
+	Authctxt *authctxt = ctxt;
+	Gssctxt *gssctxt;
+	OM_uint32 status,ms;
+	int oidlen;
+	char *oidv;
+	gss_buffer_desc send_tok;
+	
+	if (authctxt == NULL)
+		fatal("input_gssapi_response: no authentication context");
+	gssctxt = authctxt->methoddata;
+	
+	/* Setup our OID */
+	oidv=packet_get_string(&oidlen);
+	ssh_gssapi_set_oid_data(gssctxt,oidv,oidlen);
+	
+	packet_check_eom();
+	
+	status = ssh_gssapi_init_ctx(gssctxt, options.gss_deleg_creds,
+				     GSS_C_NO_BUFFER, &send_tok, 
+				     NULL);
+	if (GSS_ERROR(status)) {
+		/* Start again with next method on list */
+		debug("Trying to start again");
+		userauth(authctxt,NULL);
+		return;
+	}
+
+	/* We must have data to send */					
+	packet_start(SSH2_MSG_USERAUTH_GSSAPI_TOKEN);
+	packet_put_string(send_tok.value,send_tok.length);
+	packet_send();
+	packet_write_wait();
+	gss_release_buffer(&ms, &send_tok);
+}
+
+void
+input_gssapi_token(int type, u_int32_t plen, void *ctxt)
+{
+	Authctxt *authctxt = ctxt;
+	Gssctxt *gssctxt;
+	gss_buffer_desc send_tok,recv_tok;
+	OM_uint32 status;
+	u_int slen;
+	
+	if (authctxt == NULL)
+		fatal("input_gssapi_token: no authentication context");
+	gssctxt = authctxt->methoddata;
+	
+	recv_tok.value=packet_get_string(&slen);
+	recv_tok.length=slen;	/* safe typecast */
+
+	status=ssh_gssapi_init_ctx(gssctxt, options.gss_deleg_creds,
+				   &recv_tok, &send_tok, NULL);
+
+	packet_check_eom();
+	
+	if (GSS_ERROR(status)) {
+		/* Start again with the next method in the list */
+		userauth(authctxt,NULL);
+		return;
+	}
+	
+	if (send_tok.length>0) {
+		packet_start(SSH2_MSG_USERAUTH_GSSAPI_TOKEN);
+		packet_put_string(send_tok.value,send_tok.length);
+		packet_send();
+		packet_write_wait();
+	}
+	
+	if (status == GSS_S_COMPLETE) {
+		/* If that succeeded, send a exchange complete message */
+		packet_start(SSH2_MSG_USERAUTH_GSSAPI_EXCHANGE_COMPLETE);
+		packet_send();
+		packet_write_wait();
+	}
+}
+
+int
+userauth_external(Authctxt *authctxt)
+{
+        static int attempt =0;
+        
+        if (attempt++ >= 1)
+        	return 0;
+                                
+        debug2("userauth_external");
+        packet_start(SSH2_MSG_USERAUTH_REQUEST);
+#ifdef GSI
+        if(options.implicit && !(datafellows & SSH_BUG_GSS_EMPTYUSER)) {
+	    packet_put_cstring("");
+	} else {
+#endif
+	    packet_put_cstring(authctxt->server_user);
+#ifdef GSI
+	}
+#endif
+        packet_put_cstring(authctxt->service);
+        packet_put_cstring(authctxt->method->name);
+        packet_send();
+        packet_write_wait();
+        return 1;
+}                                                                                                
+#endif /* GSSAPI */
+
 int
 userauth_none(Authctxt *authctxt)
 {
@@ -438,6 +668,7 @@
 	packet_put_cstring(authctxt->method->name);
 	packet_send();
 	return 1;
+
 }
 
 int
diff -Naur --exclude=autom4te.cache openssh-3.4p1/sshd.c openssh-3.4p1-gsi/sshd.c
--- openssh-3.4p1/sshd.c	Tue Jun 25 18:24:19 2002
+++ openssh-3.4p1-gsi/sshd.c	Mon Sep 30 12:13:26 2002
@@ -85,6 +85,15 @@
 #include "monitor_wrap.h"
 #include "monitor_fdpass.h"
 
+#ifdef GSSAPI
+#include "ssh-gss.h"
+#endif
+
+#ifdef GSSAPI
+#include <openssl/md5.h>
+#include "bufaux.h"
+#endif /* GSSAPI */
+
 #ifdef LIBWRAP
 #include <tcpd.h>
 #include <syslog.h>
@@ -990,10 +999,13 @@
 		log("Disabling protocol version 1. Could not load host key");
 		options.protocol &= ~SSH_PROTO_1;
 	}
+#ifndef GSSAPI
+	/* The GSSAPI key exchange can run without a host key */
 	if ((options.protocol & SSH_PROTO_2) && !sensitive_data.have_ssh2_key) {
 		log("Disabling protocol version 2. Could not load host key");
 		options.protocol &= ~SSH_PROTO_2;
 	}
+#endif
 	if (!(options.protocol & (SSH_PROTO_1|SSH_PROTO_2))) {
 		log("sshd: no hostkeys available -- exiting.");
 		exit(1);
@@ -1044,6 +1056,10 @@
 	if (test_flag)
 		exit(0);
 
+#ifdef GSSAPI
+	ssh_gssapi_clean_env();
+#endif /* GSSAPI */
+
 	/*
 	 * Clear out any supplemental groups we may have inherited.  This
 	 * prevents inadvertent creation of files with bad modes (in the
@@ -1654,6 +1670,10 @@
 	if (options.afs_token_passing)
 		auth_mask |= 1 << SSH_PASS_AFS_TOKEN;
 #endif
+#ifdef GSSAPI
+	if (options.gss_authentication)
+		auth_mask |= 1 << SSH_AUTH_GSSAPI;
+#endif
 	if (options.challenge_response_authentication == 1)
 		auth_mask |= 1 << SSH_AUTH_TIS;
 	if (options.password_authentication)
@@ -1747,6 +1767,49 @@
 		for (i = 0; i < 16; i++)
 			session_id[i] = session_key[i] ^ session_key[i + 16];
 	}
+
+#ifdef GSSAPI
+  /*
+   * Before we destroy the host and server keys, hash them so we can
+   * send the hash over to the client via a secure channel so that it
+   * can verify them.
+   */
+  {
+    MD5_CTX md5context;
+    Buffer buf;
+    unsigned char *data;
+    unsigned int data_len;
+    extern unsigned char ssh1_key_digest[16];   /* in gss-genr.c */
+
+
+    debug("Calculating MD5 hash of server and host keys...");
+
+    /* Write all the keys to a temporary buffer */
+    buffer_init(&buf);
+
+    /* Server key */
+    buffer_put_bignum(&buf, sensitive_data.server_key->rsa->e);
+    buffer_put_bignum(&buf, sensitive_data.server_key->rsa->n);
+
+    /* Host key */
+    buffer_put_bignum(&buf, sensitive_data.ssh1_host_key->rsa->e);
+    buffer_put_bignum(&buf, sensitive_data.ssh1_host_key->rsa->n);
+
+    /* Get the resulting data */
+    data = (unsigned char *) buffer_ptr(&buf);
+    data_len = buffer_len(&buf);
+
+    /* And hash it */
+    MD5_Init(&md5context);
+    MD5_Update(&md5context, data, data_len);
+    MD5_Final(ssh1_key_digest, &md5context);
+
+    /* Clean up */
+    buffer_clear(&buf);
+    buffer_free(&buf);
+  }
+#endif /* GSSAPI */
+
 	/* Destroy the private and public keys. No longer. */
 	destroy_sensitive_data();
 
@@ -1797,6 +1860,45 @@
 	}
 	myproposal[PROPOSAL_SERVER_HOST_KEY_ALGS] = list_hostkey_types();
 
+#ifdef GSSAPI
+	{ 
+	char *orig;
+	char *gss = NULL;
+	char *newstr = NULL;
+       	orig = myproposal[PROPOSAL_KEX_ALGS];
+
+	/* If we don't have a host key, then all of the algorithms
+	 * currently in myproposal are useless */
+	if (strlen(myproposal[PROPOSAL_SERVER_HOST_KEY_ALGS])==0)
+		orig= NULL;
+		
+        if (options.gss_keyex)
+        	gss = ssh_gssapi_mechanisms(1,NULL);
+        else
+        	gss = NULL;
+        
+	if (gss && orig) {
+		int len = strlen(orig) + strlen(gss) +2;
+		newstr=xmalloc(len);
+		snprintf(newstr,len,"%s,%s",gss,orig);
+	} else if (gss) {
+		newstr=gss;
+	} else if (orig) {
+		newstr=orig;
+	}
+        /* If we've got GSSAPI mechanisms, then we've also got the 'null'
+	   host key algorithm, but we're not allowed to advertise it, unless
+	   its the only host key algorithm we're supporting */
+	if (gss && (strlen(myproposal[PROPOSAL_SERVER_HOST_KEY_ALGS])) == 0) {
+	  	myproposal[PROPOSAL_SERVER_HOST_KEY_ALGS]="null";
+	}
+	if (newstr)
+		myproposal[PROPOSAL_KEX_ALGS]=newstr;
+	else
+		fatal("No supported key exchange algorithms");
+        }
+#endif
+
 	/* start key exchange */
 	kex = kex_setup(myproposal);
 	kex->server = 1;
